define(["Jjump"], function(Jjump) {Jjump.createEntityBlueprint({
		name: 'player',

		scope: 'global',

		dependencies: [
			'test',
			'viewable',
			'interactable',
			'controllable'
		],

		sprites: [
			'ball2'
		],

		data: function() {
		
			this.zindex = 1;
			this.width= 28;
			this.height= 28;
			this.weight_y = 10;

			this.collide = [1];
			this.c = 0; 
			this.jumping = true; 
			this.buttonPress = false; 
			this.touchingBottom = false; 
			this.touchingTop = false;

			this.initialize = function(startX, startY) {
				this.x = startX;
				this.y = startY;
				this.appearances.addStatic('front', 'ball2', 0);
				this.appearances.set('front');

				this.bus.on('physics:collSideBottom', function() {
					this.touchingBottom = true;
				},this);

				this.bus.on('physics:collSideTop', function() {
					this.touchingTop = true;
				},this);
			};

			this.update = function(delta) {

				if(this.touchingTop) {
					this.touchingTop = false;
					this.jump.c = 0;
					this.vy = 0;
					this.touchingBottom = false;
				}

				if(this.keyDown('a')) {
					this.moveLeft(delta);
				}
				if(this.keyDown('d')) {
					this.moveRight(delta);
				}
				if(this.keyDown('w')) {
					if(this.touchingBottom && !this.buttonPress) {
						this.c = 25
						this.jumping = true;
					}
					this.buttonPress = true;
				}else {
					this.buttonPress = false;
				}

				if(this.keyDown('s')) {
					this.moveDown(delta);
				}


				this.jump(delta);

				if(this.touchingBottom) {
					this.touchingBottom = false;
					this.jumping = false;
				}
			};

			this.moveLeft = function(delta) {
				this.m_vx = -(delta/5);
			};

			this.moveRight = function(delta) {
				this.m_vx = (delta/5);
			};

			this.moveDown = function(delta) {
				this.m_vy = (delta/5);
			};

			this.jump = function(delta){
				// todo in millisecs
				if(this.c > 0 && this.buttonPress) {
					this.vy = -(delta/5*this.c/8);
					this.c -=1;
				}else {
					this.c = 0;
				}
			};
		}
	});
});